from main import *
from classes import *

def load_image(name, colorkey=None, alpha=255):
    fullname = os.path.join("data", name)
    #try:
    image = pygame.image.load(fullname)
    #except pygame.error, message:
    #    print "Can't open image:",name
    #    raise SystemExit, message
    image = image.convert()
    if colorkey is not None:
        if alpha != 255:
            image.set_alpha(alpha, RLEACCEL)
        if colorkey == -1:
            colorkey = image.get_at((0, 0))
        image.set_colorkey(colorkey, RLEACCEL)
    return image

def create_objects(directory, directory2, files, pos, obj_group, pic_group, sounds):
    i = 0
    for f in files:
        obj = load_image((directory + f), -1)
        pic = load_image((directory + f), -1, 125)
        objec = Object(obj, pos[i],(directory2 + sounds[i]), i)
        pictur = Picture(pic, pos[i])
        obj_group.add(objec)
        pic_group.add(pictur)
        i += 1

def create_animations(directory, files, pos, group):
    i = 0
    for f in files:
        anim = BG_Animation(directory, f, pos[i], i)
        group.add(anim) 
        i += 1

def initialize_fonts(num):
    if not pygame.font.get_init():
        pygame.font.init()
    font1 = pygame.font.Font("Alphabeta.ttf", 20)
    font2 = pygame.font.Font("Alphabeta.ttf", 50)
    if num == 1:
        return font1
    else:
        return font1, font2
    
def show_time(timer, font, screen):
    if timer.value_sec < 10:
        if timer.value_min < 10:
            text = font.render("0" + str(timer.value_min) + ":0" + str(timer.value_sec), False, (255,255,255))
        else:
            text = font.render(str(timer.value_min) + ":0" + str(timer.value_sec), False, (255,255,255))
    else:
        if timer.value_min < 10:
            text = font.render("0" + str(timer.value_min) + ":" + str(timer.value_sec), False, (255,255,255))
        else:
            text = font.render(str(timer.value_min) + ":" + str(timer.value_sec), False, (255,255,255))
    screen.blit(text, (668, 126))
    

"""def write_score(text, font, screen, pos):
    text = font.render(str(text), False, (0,0,0))
    screen.blit(text, pos)"""
