import os, pygame, sys, operator
from pygame.locals import*
from functions import *
from classes import *

def title():
    pygame.init()
    screen = pygame.display.set_mode((800,600))
    pygame.display.set_caption("The Fabulous Laboratory of Doctor Goldeinstein")
    pygame.mouse.set_visible(True)
    try:
        pygame.mixer.init()
    except:
        print "cannot start sound"
    
    directory = os.path.dirname(__file__)
    
    pygame.display.set_icon(pygame.image.load(directory + "\\images\icon.png"))

    if pygame.mixer.get_init():
        pygame.mixer.music.load(directory +"\\sounds\menu_dr_goldeinstein.mp3")
        pygame.mixer.music.set_volume(0.4)
        pygame.mixer.music.play(-1)

    title_screen = pygame.image.load(directory + "\\images\opening_screen.png")

    button_img = load_image(directory + "\\images\\button.png", -1)
    button = Button(button_img, (400,420))
    button_update = pygame.sprite.RenderUpdates(button)
    
    clock = pygame.time.Clock()
    
    while 1:
        clock.tick(60)
        screen.blit(title_screen, (0,0))
        button.update()
        button_update.draw(screen)
        pygame.display.flip()
        for event in pygame.event.get():
            if event.type == QUIT:
                sys.exit()
            elif event.type == KEYDOWN and event.key == K_ESCAPE:
                sys.exit()
            elif event.type == pygame.MOUSEBUTTONDOWN or event.type == KEYDOWN:
                button.kill()
                main(screen, directory)

def main(screen, directory, seen=False):
    background = pygame.image.load(directory + "\\images\\background.png")
    screen.blit(background,(0, 0))
    
    font1 = initialize_fonts(1)
    
    if pygame.mixer.get_init():
        pygame.mixer.music.load(directory + "\\sounds\\tema_dr_goldeinstein.mp3")
        pygame.mixer.music.set_volume(0.4)
        pygame.mixer.music.play(-1)

    object_files = ["\\egg.png", "\\nyan-cat.png", "\\alien.png", "\\frog.png", "\\waste.png", "\\cellphone.png", "\\baby.png", "\\anvil.png", "\\tnt.png", "\\guitar.png"]
    balloon_files = ["\\balao0.png", "\\balao1.png", "\\balao2.png", "\\balao3.png", "\\balao4.png", "\\balao5.png", "\\balao6.png", "\\balao7.png", "\\balao8.png", "\\balao9.png", "\\balao10.png"]
    sound_files = ["\\item_ovo.wav", "\\item_nyancat.wav", "\\item_alien.wav", "\\item_sapo.wav", "\\item_radioativo.wav", "\\item_phone.wav", "\\item_baby.wav", "\\item_bigorna.wav", "\\item_tnt.wav", "\\item_guitar.wav"]
    doctor_files = ["\\parado.png", "\\gesticulando1.png", "\\gesticulando2.png", "\\comemorando1.png", "\\comemorando2.png", "\\livro.png", "\\caindo1.png", "\\caindo2.png", "\\caindo3.png", "\\com_livro1.png", "\\com_livro2.png"]
    animation_files = [["\\bar1.png", "\\bar3.png", "\\bar4.png", "\\bar5.png", "\\bar6.png", "\\bar7.png", "\\bar8.png", "\\bar9.png", "\\bar10.png", "\\bar11.png", "\\bar12.png"],
                       ["\\clock1.png", "\\clock2.png", "\\clock3.png", "\\clock4.png", "\\clock5.png"],
                       ["\\lamps1.png", "\\lamps2.png", "\\lamps3.png"],
                       ["\\lustre1.png", "\\lustre2.png"],
                       ["\\onda1.png", "\\onda2.png", "\\onda3.png", "\\onda4.png", "\\onda5.png", "\\onda6.png", "\\onda7.png", "\\onda8.png", "\\onda9.png"],
                       ["\\tvzinha1.png", "\\tvzinha2.png", "\\tvzinha3.png", "\\tvzinha4.png", "\\tvzinha5.png"]]
    element_files = ["\\empty.png", "\\cezanium.png", "\\aleffico.png", "\\nicodemico.png", "\\ramonico.png", "\\marllonico.png", "\\trigueirium.png", "\\renatium.png", "\\guilermium.png", "\\rodrigum.png", "\\gold-t.png"]
    directory_sounds = directory + "\\sounds"
    directory_doctor = directory + "\\images\\doctor"
    directory_objects = directory + "\\images\\objects"
    directory_elements = directory + "\\images\\elements"
    directory_animations = directory + "\\images\\bg_animations"
    directory_balloons = directory + "\\images\\speech_balloons"
    position = [(100,180), (186,180), (100,260), (190,260), (100,356), (190,356), (100,434), (200,434), (84,500), (180,510)]
    anim_position = [(692,416), (684,326), (552,174), (254,0), (696,370), (628, 228)]

    timer = Clock()
    sequence = Sequence()
    
    machine_img = load_image(directory + "\\images\\machine.png", -1)
    machine = Picture(machine_img, (608, 544))
    stripes_img = load_image(directory + "\\images\\stripes.png", -1, 60)
    stripes = Picture(stripes_img, (588, 472))
    arrow_img = load_image(directory_animations + "\\seta.png", -1)
    arrow = Button(arrow_img, (494,100),50)
    coin_img = load_image(directory_elements + "\coin.png", -1)
    coin = Button(coin_img, (588, 460))
    doctor = Doctor(directory_doctor, doctor_files, (400, 570), directory_sounds)
    balloon0 = Balloon(directory_balloons, balloon_files, doctor)
    balloon0.run_time = 7000
    
    bg_sprites = pygame.sprite.RenderUpdates(machine)
    bg_animations = pygame.sprite.RenderUpdates(stripes, arrow)
    object_sprites = pygame.sprite.RenderUpdates()
    coin_group = pygame.sprite.RenderUpdates(coin)

    combining = pygame.mixer.Sound(directory_sounds + "\\misturando_elementos.wav")
    explosion = pygame.mixer.Sound(directory_sounds + "\\lost_explosion.wav")
    tada = pygame.mixer.Sound(directory_sounds + "\\tada.wav")
    tada.set_volume(0.7)

    create_objects(directory_objects, directory_sounds, object_files, position, object_sprites, bg_sprites, sound_files)
    create_animations(directory_animations, animation_files, anim_position, bg_animations)
    balloon_group0 = pygame.sprite.RenderUpdates(balloon0)
    doctor_group = pygame.sprite.RenderUpdates(doctor)
    stripes_group = pygame.sprite.RenderUpdates(stripes)
    
    funnel = Funnel((450, 100, 91, 11))
    
    clock = pygame.time.Clock()
    
    time = pygame.time.get_ticks() + 6000
    
    all_groups = pygame.sprite.RenderUpdates(bg_sprites, bg_animations, object_sprites)

    while balloon0.alive() and seen == False:
        clock.tick(60)
        for event in pygame.event.get():
            if event.type == QUIT:
                sys.exit()
            elif event.type == KEYDOWN and event.key == K_ESCAPE:
                sys.exit()
            elif event.type == KEYDOWN or event.type == pygame.MOUSEBUTTONDOWN:
                balloon0.kill()
                seen = True
            if pygame.time.get_ticks() >= time:
                balloon0.kill()
                seen = True
                
        bg_sprites.update()
        bg_animations.update()
        doctor_group.update()
        object_sprites.update()
        balloon_group0.update()
        screen.blit(background,(0,0))
        bg_sprites.draw(screen)
        bg_animations.draw(screen)
        doctor_group.draw(screen)
        object_sprites.draw(screen)
        balloon_group0.draw(screen)
        show_time(timer, font1, screen)
        pygame.display.flip()

    balloon = Balloon(directory_balloons, balloon_files, doctor, sequence.current_loop + 1)
    balloon_group = pygame.sprite.RenderUpdates(balloon)
    element_group = pygame.sprite.RenderUpdates()
        
    doctor.cur_behaviour = 1
    
    while 1:
        clock.tick(60)
        for event in pygame.event.get():
            if event.type == QUIT:
                sys.exit()
            elif event.type == KEYDOWN and event.key == K_ESCAPE:
                sys.exit()
            '''#uncomment this and win  
            elif event.type == KEYDOWN and event.key == K_RETURN:
                sequence.force_increase()'''
            if event.type == pygame.MOUSEBUTTONDOWN:
                for i in object_sprites:
                    i.rollover(balloon)
                    
        for i in object_sprites:
            if pygame.sprite.collide_rect(i, funnel) and i.button != (1,0,0):
                i.sound_fx.stop()
                combining.play()
                i.reset()
                a = sequence.increase(i.id)
                if a != False:
                    if a:
                        element_img = load_image(directory_elements + element_files[sequence.current_loop], -1)
                        element = Picture(element_img, (588, 460))
                        element_group = pygame.sprite.RenderUpdates(element)
                    else:
                        tada.play()
                        element_img = load_image(directory_elements + element_files[sequence.current_loop], -1)
                        element = Picture(element_img, (588, 460))
                        element_group = pygame.sprite.RenderUpdates(element)
                        balloon = Balloon(directory_balloons, balloon_files, doctor, sequence.current_loop + 1)
                        balloon_group = pygame.sprite.RenderUpdates(balloon)
                else:
                    game_over(screen, background, directory, timer, all_groups, explosion, doctor)
        
        if sequence.wanted_object == 16:
            gold_img = load_image(directory_elements + element_files[-1], -1)
            gold = Picture(gold_img, (588, 460))
            gold_group = pygame.sprite.RenderUpdates(gold)
            doctor.cur_behaviour = 5
            win(screen, background, directory, timer, all_groups, doctor_group, coin_group, gold_group, stripes_group)
        

        timer.update()
        bg_sprites.update()
        element_group.update()
        bg_animations.update()
        doctor_group.update()
        object_sprites.update()
        balloon_group.update()
        screen.blit(background,(0,0))
        bg_sprites.draw(screen)
        element_group.draw(screen)
        bg_animations.draw(screen)
        doctor_group.draw(screen)
        object_sprites.draw(screen)
        balloon_group.draw(screen)
        show_time(timer, font1, screen)
        pygame.display.flip()
        
def game_over(screen, background, directory, timer, all_groups, explosion, doctor, seen=True):
    pygame.mixer.stop()
    pygame.mixer.music.stop()
    fireball_list = ["\\explosao1.png", "\\explosao2.png"]
    fireball = BG_Animation(directory + "\\images", fireball_list, (588, 400), 8, True)
    fireball_group = pygame.sprite.RenderUpdates(fireball)
    fireball_group.add(fireball) 
    
    sign_img = load_image(directory + "\\images\\gameover.png", -1)
    sign = Picture(sign_img, (400, 310))
    sign_group = pygame.sprite.RenderUpdates(sign)
    
    explosion.play()
    doctor.cur_image = 6
    doctor.cur_behaviour = 6
    doctor_group = pygame.sprite.RenderUpdates(doctor)
    font1 = initialize_fonts(1)
    while 1:
        
        doctor_group.update()
        fireball_group.update()
        screen.blit(background,(0,0))
        all_groups.draw(screen)
        doctor_group.draw(screen)
        fireball_group.draw(screen)
        show_time(timer, font1, screen)
        sign_group.draw(screen)
        pygame.display.flip()
    
    
        for event in pygame.event.get():
            if event.type == QUIT:
                sys.exit()
            if event.type == KEYDOWN and event.key == K_ESCAPE:
                sys.exit()
            elif event.type == KEYDOWN or event.type == pygame.MOUSEBUTTONDOWN:
                all_groups.empty()
                main(screen, directory, seen)
    
def win(screen, background, directory, timer, all_groups, doctor_group, coin_group, gold_group, stripes_group):
    pygame.mixer.stop()
    pygame.mixer.music.stop()
    
    if pygame.mixer.get_init():
        pygame.mixer.music.load(directory + "\\sounds\\win_charanga.mp3")
        pygame.mixer.music.set_volume(0.4)
        pygame.mixer.music.play(-1)
    
    font1 = initialize_fonts(1)    
    while 1:
        all_groups.update()
        coin_group.update()
        doctor_group.update()
        screen.blit(background,(0,0))
        all_groups.draw(screen)
        coin_group.draw(screen)
        gold_group.draw(screen)
        stripes_group.draw(screen)
        doctor_group.draw(screen)
        show_time(timer, font1, screen)
        pygame.display.flip()
        
        for event in pygame.event.get():
            if event.type == QUIT:
                sys.exit()
            if event.type == KEYDOWN and event.key == K_ESCAPE:
                sys.exit()
            elif event.type == KEYDOWN or event.type == pygame.MOUSEBUTTONDOWN:
                sys.exit()
        
if __name__ == '__main__': title()

"""""""""
credits:
basic drag and drop code: jean-pat
programming: willmeira
art: renato morais & rodrigo motta
music: ramon lima
"""""""""
